/**
 * generated by Xtext 2.19.0.M3
 */
package fr.irisa.cairn.graphviz.model.dotty.impl;

import fr.irisa.cairn.graphviz.model.dotty.*;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.impl.EFactoryImpl;

import org.eclipse.emf.ecore.plugin.EcorePlugin;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Factory</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class DottyFactoryImpl extends EFactoryImpl implements DottyFactory
{
  /**
   * Creates the default factory implementation.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static DottyFactory init()
  {
    try
    {
      DottyFactory theDottyFactory = (DottyFactory)EPackage.Registry.INSTANCE.getEFactory(DottyPackage.eNS_URI);
      if (theDottyFactory != null)
      {
        return theDottyFactory;
      }
    }
    catch (Exception exception)
    {
      EcorePlugin.INSTANCE.log(exception);
    }
    return new DottyFactoryImpl();
  }

  /**
   * Creates an instance of the factory.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public DottyFactoryImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public EObject create(EClass eClass)
  {
    switch (eClass.getClassifierID())
    {
      case DottyPackage.GRAPH: return createGraph();
      case DottyPackage.COMPOUND: return createCompound();
      case DottyPackage.NODE: return createNode();
      case DottyPackage.LEAF_NODE: return createLeafNode();
      case DottyPackage.SUB_NODE: return createSubNode();
      case DottyPackage.ATTRIBUTE: return createAttribute();
      case DottyPackage.SHAPE_ATTRIBUTE: return createShapeAttribute();
      case DottyPackage.COMPOUND_ATTRIBUTE: return createCompoundAttribute();
      case DottyPackage.COLOR_ATTRIBUTE: return createColorAttribute();
      case DottyPackage.STYLE_ATTRIBUTE: return createStyleAttribute();
      case DottyPackage.LABEL_ATTRIBUTE: return createLabelAttribute();
      case DottyPackage.RANK_ATTRIBUTE: return createRankAttribute();
      default:
        throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
    }
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Graph createGraph()
  {
    GraphImpl graph = new GraphImpl();
    return graph;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Compound createCompound()
  {
    CompoundImpl compound = new CompoundImpl();
    return compound;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Node createNode()
  {
    NodeImpl node = new NodeImpl();
    return node;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public LeafNode createLeafNode()
  {
    LeafNodeImpl leafNode = new LeafNodeImpl();
    return leafNode;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public SubNode createSubNode()
  {
    SubNodeImpl subNode = new SubNodeImpl();
    return subNode;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Attribute createAttribute()
  {
    AttributeImpl attribute = new AttributeImpl();
    return attribute;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public ShapeAttribute createShapeAttribute()
  {
    ShapeAttributeImpl shapeAttribute = new ShapeAttributeImpl();
    return shapeAttribute;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public CompoundAttribute createCompoundAttribute()
  {
    CompoundAttributeImpl compoundAttribute = new CompoundAttributeImpl();
    return compoundAttribute;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public ColorAttribute createColorAttribute()
  {
    ColorAttributeImpl colorAttribute = new ColorAttributeImpl();
    return colorAttribute;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public StyleAttribute createStyleAttribute()
  {
    StyleAttributeImpl styleAttribute = new StyleAttributeImpl();
    return styleAttribute;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public LabelAttribute createLabelAttribute()
  {
    LabelAttributeImpl labelAttribute = new LabelAttributeImpl();
    return labelAttribute;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public RankAttribute createRankAttribute()
  {
    RankAttributeImpl rankAttribute = new RankAttributeImpl();
    return rankAttribute;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public DottyPackage getDottyPackage()
  {
    return (DottyPackage)getEPackage();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @deprecated
   * @generated
   */
  @Deprecated
  public static DottyPackage getPackage()
  {
    return DottyPackage.eINSTANCE;
  }

} //DottyFactoryImpl
